<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter" :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div v-show="showSearch" class="mb-[10px]">
        <el-card shadow="hover">
          <el-form ref="queryFormRef" :model="queryParams" :inline="true">
            <el-form-item label="页面名称" prop="name">
              <el-input v-model="queryParams.name" placeholder="请输入页面名称" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item label="扩展1" prop="ext1">
              <el-input v-model="queryParams.ext1" placeholder="请输入扩展1" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item label="扩展2" prop="ext2">
              <el-input v-model="queryParams.ext2" placeholder="请输入扩展2" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item>
              <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
              <el-button icon="Refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
          </el-form>
        </el-card>
      </div>
    </transition>

    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['system:page:add']">新增</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate()" v-hasPermi="['system:page:edit']">修改</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete()" v-hasPermi="['system:page:remove']">删除</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['system:page:export']">导出</el-button>
          </el-col>
          <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>
      </template>

      <el-table v-loading="loading" :data="pageList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="编号" align="center" prop="id" v-if="true" />
        <el-table-column label="页面名称" align="center" prop="name" />
        <el-table-column label="页面数据" align="center" prop="content" >
          <template #default="scope">
            <el-tooltip :content="scope.row.content" placement="top">
              <span style="max-height:100px;display: inline-block;overflow: hidden;white-space: nowrap;text-overflow: ellipsis;">{{scope.row.content}}</span>
            </el-tooltip>
          </template>
        </el-table-column>
        <el-table-column label="扩展1" align="center" prop="ext1" />
        <el-table-column label="扩展2" align="center" prop="ext2" />
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-tooltip content="修改" placement="top">
              <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['system:page:edit']"></el-button>
            </el-tooltip>
            <el-tooltip content="删除" placement="top">
              <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['system:page:remove']"></el-button>
            </el-tooltip>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改页面对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="80vw" append-to-body>
      <el-form ref="pageFormRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="页面名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入页面名称"  :autosize="{ minRows: 120}"/>
        </el-form-item>
        <el-form-item label="页面数据">
          <el-input type="textarea" v-model="form.content"  />
          <div style="padding-top: 10px;display:flex;justify-content: flex-end;width: 100%;">
            <div >
              <el-button type="primary" @click="editpage">页面编辑</el-button>
            </div>
            <div style="margin-left:10px">
              <el-button type="primary" @click="preview">页面预览</el-button>
            </div>
          </div>

        </el-form-item>
        <el-form-item label="扩展1" prop="ext1">
            <el-input v-model="form.ext1" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="扩展2" prop="ext2">
            <el-input v-model="form.ext2" type="textarea" placeholder="请输入内容" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>

    <el-dialog title="页面预览" v-model="isPreview" style="height:90vh" width="80vw"  append-to-body>
      <AMISRenderer :key="previewdata" :formjson="previewdata" />
    </el-dialog>

  </div>
</template>

<script setup name="Page" lang="ts">
import { listPage, getPage, delPage, addPage, updatePage } from '@/api/system/page';
import { PageVO, PageQuery, PageForm } from '@/api/system/page/types';
import { Base64 } from 'js-base64';
import { cloneDeep } from 'lodash';
import { c } from 'node_modules/vite/dist/node/types.d-aGj9QkWt';





const  isPreview = ref(false);
const  previewdata = ref({});



const { proxy } = getCurrentInstance() as ComponentInternalInstance;

const pageList = ref<PageVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);


const queryFormRef = ref<ElFormInstance>();
const pageFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: PageForm = {
  id: undefined,
  name: undefined,
  content: undefined,
  ext1: undefined,
  ext2: undefined
}
const data = reactive<PageData<PageForm, PageQuery>>({
  form: {...initFormData},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    name: undefined,
    content: undefined,
    ext1: undefined,
    ext2: undefined,
    params: {
    }
  },
  rules: {
    id: [
      { required: true, message: "编号不能为空", trigger: "blur" }
    ],
    name: [
      { required: true, message: "页面名称不能为空", trigger: "blur" }
    ]
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询页面列表 */
const getList = async () => {
  loading.value = true;
  const res = await listPage(queryParams.value);
  pageList.value = res.rows;
  total.value = res.total;
  loading.value = false;
}

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
}

/** 表单重置 */
const reset = () => {
  form.value = {...initFormData};
  pageFormRef.value?.resetFields();
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
}

/** 多选框选中数据 */
const handleSelectionChange = (selection: PageVO[]) => {
  ids.value = selection.map(item => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = "添加页面";
}

/** 修改按钮操作 */
const handleUpdate = async (row?: PageVO) => {
  reset();
  const _id = row?.id || ids.value[0]
  const res = await getPage(_id);
  Object.assign(form.value, res.data);
  localStorage.setItem("pageSchema", form.value.content);
  dialog.visible = true;
  dialog.title = "修改页面";
}

/** 提交按钮 */
const submitForm = () => {
  pageFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.id) {
        let v = cloneDeep(form.value);
        v.content = Base64.encode(v.content);
        await updatePage(v).finally(() =>  buttonLoading.value = false);
      } else {
         let v = cloneDeep(form.value);
        v.content = Base64.encode(v.content);
        await addPage(v).finally(() =>  buttonLoading.value = false);
      }
      proxy?.$modal.msgSuccess("操作成功");
      dialog.visible = false;
      await getList();
    }
  });
}

/** 删除按钮操作 */
const handleDelete = async (row?: PageVO) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm('是否确认删除页面编号为"' + _ids + '"的数据项？').finally(() => loading.value = false);
  await delPage(_ids);
  proxy?.$modal.msgSuccess("删除成功");
  await getList();
}

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download('system/page/export', {
    ...queryParams.value
  }, `page_${new Date().getTime()}.xlsx`)
}

let ttim = null;
const editpage = ()=>{

  localStorage.setItem("pageSchema", form.value.content);
  localStorage.setItem("localhttppath", import.meta.env.VITE_APP_BASE_API);
  localStorage.setItem("clientid", import.meta.env.VITE_APP_CLIENT_ID);
  //读取页面数据
  if (ttim) clearInterval(ttim);
  ttim = setInterval(() => {
    if (!dialog.visible) {
      clearInterval(ttim);
    }
    form.value.content = localStorage.getItem("pageSchema");
  },1000)
  window.open('/editor/index.html')
}

const  preview = ()=>{
  let jsondata = "{}";
  try{
    console.log(form.value.content)
    jsondata =  JSON.parse(form.value.content);


  }catch (e){}
  previewdata.value = jsondata;
  isPreview.value = true;

}


onMounted(() => {
  getList();
});
</script>
